%%
clc
clear;

%% read image and construct linear operator
img = im2double(imread('cat_spnoise.jpg'));
[ny, nx, c] = size(img);
n = ny*nx*c;
f = img(:);

% TODO: construct the linear operator for 3 channels.
e = ones(ny, 1);
A = spdiags([-e e], 0:1, ny, ny);
A(end, end) = 0;
Dy = kron(speye(nx), A);
e = ones(nx, 1);
B = spdiags([-e e], 0:1, nx, nx)';
B(:, end) = 0;
Dx = kron(B', speye(ny));
D = cat(1, kron(speye(3), Dx), kron(speye(3), Dy));

%% optimization part
% initialize the parameters
u = zeros(size(D,2),1);
p = zeros(size(D,1),1);
max_iters = 5000;

% weight for regularizor
rho = 0.6;

% arrays to record the energy.
primal_eng = zeros(1,max_iters);
dual_eng = zeros(1,max_iters);

D = rho*D;

norm_D = rho * sqrt(8);
s = 1.1*norm_D;
t = 1.1*norm_D;

% TODO: Implement the majorize minimization and at each iteration, check
% the duality gap.
for i = 1:max_iters
    u_prev = u;
    tmp_u = u-D'*p/s;
    u = f;
    u(tmp_u+1/s<f) = tmp_u(tmp_u+1/s<f)+1/s;
    u(tmp_u-1/s>f) = tmp_u(tmp_u-1/s>f)-1/s;
   % sum(abs(u-f))
    u_bar = 2*u-u_prev;
    
    p = p + D*u_bar/t;
    p = max(min(p, 1),-1);
    
    primal_eng(i) = sum(abs(u-f)) + sum(abs(D*u));
    dual_eng(i) = -f'*D'*p;
    
    fprintf('iteration: %d, duality gap: %.4e\n', i, primal_eng(i) + dual_eng(i));
end

%% visualization
imshow(reshape(u, ny, nx,c));